
freeslot("sfx_smwkck", "S_SMW_KICK")

sfxinfo[sfx_smwkck].caption = "Kick"

states[S_SMW_KICK] = {
    sprite = SPR_PLAY,
    frame = SPR2_MLEL,
    tics = TICRATE/4,
    nextstate = S_PLAY_STND
}

freeslot("SPR2_GTND", "SPR2_GLEE", "SPR2_GALK", "SPR2_GALK", "SPR2_GUMP", "SPR2_GAND", "S_GRAB_STND", "S_GRAB_WALK", "S_GRAB_RUN", "S_GRAB_JUMP", "S_GRAB_CROUCH")

function A_ChangePAnim(mo, v1, v2)
	if mo.type ~= MT_PLAYER error("this ain't no player") return end
	if not v1 error("where are your var1") return end
	
	mo.player.panim = v1
end

states[S_GRAB_STND] = {
    sprite = SPR_PLAY,
    frame = SPR2_GTND,
    tics = -1,
	action = A_ChangePAnim,
	var1 = PA_IDLE,
    nextstate = S_GRAB_STND
}

states[S_GRAB_WALK] = {
    sprite = SPR_PLAY,
    frame = SPR2_GALK,
    tics = states[S_PLAY_WALK].tics,
	action = A_ChangePAnim,
	var1 = PA_WALK,
    nextstate = S_GRAB_WALK
}

states[S_GRAB_RUN] = {
    sprite = SPR_PLAY,
    frame = SPR2_GALK,
    tics = states[S_PLAY_RUN].tics,
	action = A_ChangePAnim,
	var1 = PA_RUN,
    nextstate = S_GRAB_RUN
}

states[S_GRAB_JUMP] = {
    sprite = SPR_PLAY,
    frame = SPR2_GUMP,
    tics = -1,
    nextstate = S_GRAB_JUMP
}

states[S_GRAB_CROUCH] = {
    sprite = SPR_PLAY,
    frame = SPR2_GAND,
    tics = -1,
    nextstate = S_GRAB_CROUCH
}

local grabstates = {}

grabstates[S_PLAY_STND] = S_GRAB_STND
grabstates[S_PLAY_WALK] = S_GRAB_WALK
grabstates[S_PLAY_RUN] = S_GRAB_RUN
grabstates[S_PLAY_JUMP] = S_GRAB_JUMP
grabstates[S_PLAY_GLIDE_LANDING] = S_GRAB_CROUCH
grabstates[S_GRAB_STND] = S_GRAB_STND
grabstates[S_GRAB_WALK] = S_GRAB_WALK
grabstates[S_GRAB_RUN] = S_GRAB_RUN
grabstates[S_GRAB_CROUCH] = S_GRAB_CROUCH

addHook("ThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.mo.valid)
		or (p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi") continue end
		
		if p.smwgrab == nil
			p.smwgrab = false
		end
		
		if p.smwgrab
		and (p.smwgrabmobj and p.smwgrabmobj.valid)
			local x = cos(p.drawangle)
			local y = sin(p.drawangle)
			P_MoveOrigin(p.smwgrabmobj, p.mo.x+32*x, p.mo.y+32*y, p.mo.z)
			p.smwgrabmobj.flags = $1|MF_NOCLIPTHING|MF_NOGRAVITY
			if p.mo.state ~= S_SMW_KICK
			and p.playerstate ~= PST_DEAD
			and not P_PlayerInPain(p)
				if grabstates[p.mo.state]
				and p.mo.state ~= grabstates[p.mo.state]
					p.mo.state = grabstates[p.mo.state]
				elseif not grabstates[p.mo.state]
					p.mo.state = S_GRAB_JUMP
				end
			end
			if not (p.cmd.buttons & BT_SPIN)
			or P_PlayerInPain(p)
			or p.playerstate == PST_DEAD
				if not (P_PlayerInPain(p)
				or p.playerstate == PST_DEAD)
					p.mo.state = S_SMW_KICK
					S_StartSound(p.mo, sfx_smwkck)
				end
				local speed = 36*FU
				if (p.cmd.buttons & BT_CUSTOM2)
					speed = 5*FU
				end
				P_InstaThrust(p.smwgrabmobj, p.drawangle, speed)
				p.smwgrab = false
				p.smwgrabmobj.smwhurtable = true
				p.smwgrabmobj.smwtimer = TICRATE/8
				p.smwgrabmobj.smwplyr = true
			end
		elseif p.smwgrab
		and not (p.smwgrabmobj and p.smwgrabmobj.valid)
			p.smwgrab = false
			p.smwgrabmobj = nil
		end
		
		if p.smwgrabmobj
		and p.smwgrabmobj.smwplyr
			local mo = p.smwgrabmobj
			if mo.smwtimer
				mo.smwtimer = $-1
			else
				mo.flags = mo.smwoldflags
				mo.smwplyr = nil
				p.smwgrabmobj = nil
			end
		end
	end
end)

local function SMWGrab(pmo, mo)
	if not (pmo and pmo.valid)
	or (pmo.skin ~= "smwmario" and pmo.skin ~= "smwluigi")
	or pmo.player.smwgrab
	or not (mo and mo.valid)
	or not (mo.flags & MF_PUSHABLE) return end
	
	if mo.z > pmo.z+pmo.height
	or pmo.z > mo.z+mo.height return end
	
	local p = pmo.player
	
	if (p.cmd.buttons & BT_SPIN)
		mo.smwoldflags = mo.flags
		p.smwgrabmobj = mo
		p.smwgrab = true
	end
end

addHook("MobjCollide", SMWGrab, MT_PLAYER)
addHook("MobjMoveCollide", SMWGrab, MT_PLAYER)