
freeslot("MT_SMW_STUNENMY", "sfx_smwstp")

mobjinfo[MT_SMW_STUNENMY] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_INVISIBLE,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	flags = MF_PUSHABLE,
	radius = 16*FU,
	height = 16*FU
}

sfxinfo[sfx_smwstp].caption = "Boot-stomp"

addHook("MobjDamage", function(mo, pmo)
	if not (mo and mo.valid)
	or not (mo.flags & MF_ENEMY)
	or not (pmo and pmo.valid)
	or (pmo.skin ~= "smwmario" and pmo.skin ~= "smwluigi")
	or pmo.state == S_PLAY_SMW_SPINJUMP return end
	
	local p = pmo.player
	
	local stun = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMW_STUNENMY)
	stun.target = mo
	stun.tracer = pmo
	stun.radius = mo.radius
	stun.height = mo.height
	stun.shakeadd = FU
	stun.shake = 0
	stun.sprite = states[mo.info.spawnstate].sprite
	stun.frame = A
	stun.rollangle = ANGLE_180
	stun.mirrored = true
	mo.state = S_INVISIBLE
	mo.smwoldflags = mo.flags
	mo.flags = 0
	P_InstaThrust(stun, R_PointToAngle2(pmo.x, pmo.y, stun.x, stun.y), 10*FU)
	S_StartSound(mo, sfx_smwstp)
	return true
end)

addHook("MobjThinker", function(mo)
	if mo.smwstuntime == nil
		mo.smwstuntime = 0
	end
	
	if mo.smwhurtable
	and (mo.momx == 0 and mo.momy == 0)
		mo.smwhurtable = false
	end
	
	local enmy = mo.target
	if not (enmy and enmy.valid) return end
	
	local maxstuntime = 8*TICRATE
	
	mo.smwstuntime = $+1
	P_SetOrigin(enmy, mo.x, mo.y, mo.z)
	mo.spritexoffset = mo.shake
	if mo.smwstuntime >= FixedDiv(maxstuntime*FU, FixedDiv(3*FU, 2*FU))/FU --maxstuntime/2
		if mo.shake < 5*FU
		and mo.shake > -5*FU
			mo.shake = $+mo.shakeadd*(mo.smwstuntime/(maxstuntime/2))*2
		elseif mo.shake >= 5*FU
		or mo.shake <= -5*FU
			if mo.shake > 5*FU
			or mo.shake < -5*FU
				mo.shake = 5*mo.shakeadd
			end
			mo.shakeadd = -$
			mo.shake = $+mo.shakeadd
		end
	end
	if mo.smwstuntime == maxstuntime
		enmy.state = enmy.info.spawnstate
		enmy.flags = enmy.smwoldflags
		P_LookForPlayers(enmy)
		enmy.angle = R_PointToAngle2(enmy.x, enmy.y, enmy.target.x, enmy.target.y)
		P_SetObjectMomZ(enmy, 3*FU)
		if mo.tracer.player.smwgrab
			mo.tracer.player.smwgrab = false
			mo.tracer.player.smwgrabmobj = nil
			enmy.flags = enmy.smwoldflags
			enmy.smwoldflags = nil
		end
		P_RemoveMobj(mo)
	end
end, MT_SMW_STUNENMY)

local function SMWkillstuff(mo, mo2)
	if not (mo and mo.valid)
	or not (mo2 and mo2.valid)
	or not (mo2.flags & MF_ENEMY)
	or not (mo.tracer.player.smwgrab or mo.smwhurtable) return end
	
	if mo.z > mo2.z+mo2.height
	or mo2.z > mo.z+mo.height return end
	
	P_KillMobj(mo2, mo, mo.tracer)
	mo.target.flags = mo.target.smwoldflags
	P_KillMobj(mo.target, mo, mo.tracer)
	mo.tracer.player.smwgrab = false
	mo.tracer.player.smwgrabmobj = nil
	P_RemoveMobj(mo)
end

addHook("MobjCollide", SMWkillstuff, MT_SMW_STUNENMY)
addHook("MobjMoveCollide", SMWkillstuff, MT_SMW_STUNENMY)